from PyGlut import *
import Cavernosa

count = 0
mouse_x = 0
mouse_y = 0
viewport_width_ = 512
viewport_height_ = 512
key_is_down = 1
key_is_up = 0

def display():
    global count
#    print 'Cavernosa Script display func called'
    count = count + 1
    Cavernosa.display()
    glutSwapBuffers()
    glutPostRedisplay()
#    if count > 10: glutDestroyWindow(win_id)
#! Destroy properly.

def reshape(x, y):
    global viewport_width_, viewport_height_
    viewport_width_ = x
    viewport_height_ = y
    Cavernosa.reshape(0, 0, x, y)

def motion(x, y):
    global mouse_x, mouse_y
    mouse_x = x
    mouse_y = viewport_height_ - y 
#    print 'Python motion(x,y) func called: ', x, y
    Cavernosa.motion(x, viewport_height_ - y)

def passive_motion(x, y):
    global mouse_x, mouse_y
    mouse_x = x
    #mouse_y = y
    mouse_y = viewport_height_ - y 
    #print 'Python passive_motion(x,viewport_height_ - y) func called: ', x, y
    Cavernosa.motion(x, viewport_height_ - y)


def mouse(but, state, x, y):
    Cavernosa.motion(x, viewport_height_ - y)
    Cavernosa.button(but, state)

def key_down(key, x, y):
    print 'key_down called with key: ', key
    Cavernosa.motion(x, viewport_height_ - y)
    Cavernosa.key(key, key_is_down)
    if key == ord('p'):
        Cavernosa.set_string(Cavernosa.StringSavePath, "Test.vox")
        Cavernosa.do_action(Cavernosa.ActionSave) # Save
    elif key == ord('o'):
        Cavernosa.set_string(Cavernosa.StringSavePath, "Test.vox")
        Cavernosa.do_action(Cavernosa.ActionLoad) # Load
    elif key == ord('i'): Cavernosa.do_action(Cavernosa.ActionNewClearGrid) # Clear Grid.
    elif key == ord('u'): Cavernosa.do_action(Cavernosa.ActionNewSolidGrid) # Clear Grid.
    elif key == ord('q'): Cavernosa.do_action(Cavernosa.ActionToggleMovement)
    elif key == ord('e'): Cavernosa.do_action(Cavernosa.ActionChangeGridAffector)
    elif key == ord('y'): toggle_bool(Cavernosa.BoolDisplayGridAsSquares)
    elif key == ord('t'): toggle_bool(Cavernosa.BoolDisplayGridAsLimitMCA)
    elif key == ord('r'): toggle_bool(Cavernosa.BoolDisplayVertIndex)
    elif key == ord('w'): toggle_bool(Cavernosa.BoolDisplayWithAdditiveBlend)
    elif key == ord('u'): toggle_bool(Cavernosa.BoolCountFaces)
    # Setting the grid dimension:
    elif key == ord('3'): Cavernosa.set_int(Cavernosa.IntGridLevels, 3)
    elif key == ord('4'): Cavernosa.set_int(Cavernosa.IntGridLevels, 4)
    elif key == ord('5'): Cavernosa.set_int(Cavernosa.IntGridLevels, 5)
    elif key == ord('6'): Cavernosa.set_int(Cavernosa.IntGridLevels, 6)
    elif key == ord('7'): Cavernosa.set_int(Cavernosa.IntGridLevels, 7)

def key_up(key, x, y):
    print 'key_up called with key: ', key
    Cavernosa.motion(x, viewport_height_ - y)
    Cavernosa.key(key, key_is_up)

def toggle_bool(bool_):
    if Cavernosa.query_bool(bool_) == 1:
        Cavernosa.set_bool(bool_, 0)
    else:
        Cavernosa.set_bool(bool_, 1)


print " next: glutInit(1, ['poop'])"
glutInit(1, ['Cavernosa'])

print " next: glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB) # RGBA"
glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB) # RGBA
#print " next: glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB) # RGBA"
#glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB) # RGBA

print " next: glutInitWindowPosition(0, 0)"
glutInitWindowPosition(0, 0)

print " next: glutInitWindowSize(512, 512)"
glutInitWindowSize(viewport_width_, viewport_height_)

print " next: win_id = glutCreateWindow('Cavernosa')"
win_id = glutCreateWindow('Cavernosa')

print " next: glutDisplayFunc(display)"
glutDisplayFunc(display)
glutReshapeFunc(reshape)

print " next: glutMotionFunc(motion) etc..."
glutMotionFunc(motion)
glutPassiveMotionFunc(passive_motion)
glutMouseFunc(mouse)
glutIgnoreKeyRepeat(1)
glutKeyboardFunc(key_down)
glutKeyboardUpFunc(key_up)

print " next: glutMainLoop()"
glutMainLoop()

print 'Script Terminated.'